{% extends "template/app.twig" %}

{% block meta %}
    {% set meta = {'keywords': 'Oportunidades'} %}
    {{ parent() }}
{% endblock %}

{% block link %}
    {{ parent() }}
{% endblock %}

{% block header %}
    {{ parent() }}
{% endblock %}

{% block aside %}
    {{ parent() }}
{% endblock %}

{% block content %}
    {{ parent() }}
    {% include "template/partial/section/group_brand_list.twig" %}
{% endblock %}

{% block footer %}
    {{ parent() }}
{% endblock %}

{% block script %}
    {{ parent() }}

    <script>
        $(document).ready(function () {

            //Selection
            var gridClient = $("#data-table-group-brand").bootgrid({
                css: {
                    icon: 'zmdi icon',
                    iconColumns: 'zmdi-view-module',
                    iconDown: 'zmdi-expand-more',
                    iconRefresh: 'zmdi-refresh',
                    iconUp: 'zmdi-expand-less'
                },
                templates: {
                    header: ""
                },
                selection: false,
                multiSelect: false,
                rowSelect: false,
                keepSelection: false,
                statusMappings: {
                    4: "bgm-bluegray",
                    5: "bgm-pink"
                },
                formatters: {
                    "commands": function (column, row) {
                        return "<button type=\"button\" class=\"btn btn-icon command-edit waves-effect waves-circle lo-e\" title=\"Editar grupo\"  data-id=\"" + row.id + "\" data-name=\"" + row.name + "\"><span class=\"zmdi zmdi-edit\"></span></button> " +
                                "<button type=\"button\" class=\"btn btn-icon command-delete waves-effect waves-circle lo-d\" title=\"Eliminar grupo\" data-id=\"" + row.id + "\"><span class=\"zmdi zmdi-delete\"></span></button>";
                    }
                }
            }).on("loaded.rs.jquery.bootgrid", function () {
                gridClient.find(".lo-e").on("click", function (e) {

                    var id = $(this).data("id");
                    var name = $(this).data("name");
                    $('#modalDefault').find('.modal-title:first').text('Actualizar Grupo');
                    $('#form-new-group-brand').attr('data-action', 'put');
                    $('#group_brand_id').val(id);
                    $('#group_name').val(name);
                    
                    getBrandsGroup(id);
                    $('#modalDefault').modal('show');
                });

                gridClient.find(".lo-d").on("click", function (e) {
                    var id = $(this).data("id");

                    swal({
                        title: "¿Está seguro de eliminar el grupo?",
                        text: "Se perderan todos los datos ingresados!",
                        type: "warning",
                        showCancelButton: true,
                        confirmButtonColor: "#DD6B55",
                        confirmButtonText: "Borrar",
                        cancelButtonText: "Cancelar",
                        closeOnConfirm: true
                    }, function (isConfirm) {
                        if (isConfirm) {
                            $.ajax({
                                type: "DELETE",
                                url: '{{path_for('group-brand-delete')}}',
                                data: {group_brand_id: id},
                                dataType: "JSON",
                                success: function (data) {
                                    console.log(data);
                                    if (data.type > 1) {
                                        notify(data.message, 'success');
                                        setTimeout(function () {
                                            window.location.reload();
                                        }, 300);
                                    } else {
                                        notify(data.message, 'warning');
                                    }
                                },
                                error: function (data) {
                                    console.log(data);
                                    notify('Ha ocurrido un error, por favor intente de nuevo!', 'warning');
                                }
                            });
                        }
                    });
                });
            });

            //save
            $(document).on('click', '.save-group-brand', function () {
                var type = $("#form-new-group-brand").data('action');
                                
                if (isCheckSave()) {
                    $.ajax({
                        type: type,
                        url: (type === 'put') ? '{{path_for('group-brand-update')}}' : '{{path_for('group-brand-create')}}',
                        data: $('#form-new-group-brand').serializeArray(),
                        dataType: "JSON",
                        success: function (data) {
                            console.log(data);
                            if (data.type > 1) {
                                notify(data.message, 'success');
                                setTimeout(function () {
                                    window.location.reload();
                                }, 300);
                            } else {
                                notify(data.message, 'warning');
                            }
                        },
                        error: function (data) {
                            console.log(data);
                            notify('Ha ocurrido un error, por favor intente de nuevo!', 'warning');
                        }
                    });
                } else {
                    $('#modal-msg').html('\
                        <div class="alert alert-warning alert-dismissible" role="alert">\n\
                            <button type="button" class="close" data-dismiss="alert" aria-label="Close">\n\
                                <span aria-hidden="true">×</span>\n\
                            </button>\n\
                            Completá los campos resaltados\n\
                        </div>'
                    ).show('slow');
                }
            });

            var getBrandsGroup = function (id) {
                $.ajax({
                    type: 'GET',
                    url:'{{path_for('group-brands', {'id': id})}}'+id,
                    dataType: "JSON",
                    success: function (data) {
                        var ids = [];
                        $.each(data.users, function(k, v){
                            ids.push(v.brand_id);
                        });
                        $('#brands').val(ids).trigger('chosen:updated');
                    },
                    error: function (data) {
                        console.log(data);
                        notify('Ha ocurrido un error, al intentar cargar los usuarios!', 'warning');
                    }
                });
            };
            //check form
            var isCheckSave = function () {
                var is = true;
                
                if ($('#group_name').val() === '') {
                    $('#group_name').parents('.fg-line').addClass('has-error');
                    is = false;
                }
                return is;
            };
            
            $('#modalDefault').on('hidden.bs.modal', function () {
                $.each($('#brands option'), function(){
                    $(this).removeAttr('selected');
                });
                $('#brands').trigger('chosen:updated');
                $('#group_name').val('');
                $('#group_name').parents('.fg-line').removeClass('has-error');
            });
            
            $(document).on('blur', '#group_name', function () {
                if ($(this).val() !== '') {
                    $(this).parents('.fg-line').removeClass('has-error');
                    $('#modal-msg').hide('slow');
                }
            });
            
            $(document).on('click', '#create-group-brand', function () {
                $('#form-new-group-brand').attr('data-action', 'post');
                $('#modalDefault').find('.modal-title:first').text('Nuevo Grupo');
            });
        });
    </script>

{% endblock %}